package com.tzld.piaoquan.recommend.server.util;

import com.alibaba.fastjson.JSONObject;
import com.google.common.reflect.TypeToken;
import com.google.gson.Gson;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;

import java.util.Collections;
import java.util.Map;

@Slf4j
public class JSONUtils {


    public static String toJson(Object obj) {
        if (obj == null) {
            return "";
        }
        try {
            return new Gson().toJson(obj);
        } catch (Exception e) {
            log.error("toJson exception", e);
            return "";
        }
    }

    public static <T> T fromJson(String value, TypeToken<T> typeToken, T defaultValue) {

        if (StringUtils.isBlank(value)) {
            return defaultValue;
        }
        try {
            return JSONObject.parseObject(value, typeToken.getType());
        } catch (Exception e) {
            log.error("parseObject error! value=[{}]", value, e);
        }
        return defaultValue;
    }

    public static void main(String[] args) {
        String json = "{\"code\":-111,\"msg\":\"未知系统异常,请联系管理员\",\"data\":null,\"errorData\":null,\"extData\":null," +
                "\"otherData\":null,\"extInfo\":null}";
        Map<String, String> map = fromJson(json, new TypeToken<Map<String, String>>() {
        }, Collections.emptyMap());
        System.out.println("");
    }
}
